
--- OBJECT CONFIG ---
freeslot("MT_BESTIEBALL", "SPR_RPBAA0", "S_BESTBAL") -- Bestie ball
freeslot("MT_TRYWHIP", "SPR_RPIWA0", "S_BESTWIP") -- Try instawhip

-- ball
states[S_BESTBAL] = {
	sprite = SPR_RPBAA0,
	frame = A,
	tics = -1,
	action = nil,
	var1 = 0,
	var2 = 0,
	nextstate = S_NULL
}
-- instawhip icon
states[S_BESTWIP] = {
	sprite = SPR_RPIWA0,
	frame = A,
	tics = -1,
	action = nil,
	var1 = 0,
	var2 = 0,
	nextstate = S_NULL
}


-- ball
mobjinfo[MT_BESTIEBALL] = {
	doomednum = 5604, -- UDMF metadata
	--$Name Bestie Ball
	--$Sprite RPBAL0
	spawnstate = S_BESTBAL,
	deathstate = S_NULL,
    spawnhealth = 2,
	speed = 20,
	radius = 32*FRACUNIT,
	height = 48*FRACUNIT,
	flags = MF_SPECIAL|MF_APPLYTERRAIN|MF_SLOPE --|MF_SHOOTABLE|MF_DONTPUNT
}
-- instawhip icon
mobjinfo[MT_TRYWHIP] = {
	doomednum = -1, -- UDMF metadata
	spawnstate = S_BESTWIP,
	deathstate = S_NULL,
    spawnhealth = 1000,
	speed = 0,
	radius = 32*FRACUNIT,
	height = 48*FRACUNIT,
	flags = MF_NOCLIP|MF_NOGRAVITY|MF_SCENERY|MF_DONTENCOREMAP
}

-- debug
-- addHook("PlayerThink", function(player)
-- 	-- print(player.instashield)
-- 	-- print("power: " + K_PowerUpRemaining(player, POWERUP_BARRIER))
-- 	if player.bot
-- 		--player.mo.destscale = mapheaderinfo[gamemap].mobj_scale*6
-- 		--if K_PowerUpRemaining(player, POWERUP_BARRIER) == 0 K_GivePowerUp(player, POWERUP_BARRIER, TICRATE*999) end
-- 	end
-- end)
--- ---



addHook("MobjSpawn", function(mobj)
	-- init values at spawn
	mobj.beastie_Decay = 0
	mobj.beastie_Bounce = 0
	mobj.beastie_Power = 0
	mobj.beastie_Respawntime = 0

	mobj.color = 5

	mobj.beastie_SpawnX = mobj.x
	mobj.beastie_SpawnY = mobj.y
	mobj.beastie_SpawnZ = mobj.z

	mobj.bestie_icon = P_SpawnMobj(mobj.x, mobj.y, mobj.z+120*FRACUNIT, MT_TRYWHIP)
	mobj.bestie_icon.destscale = $*3
end, MT_BESTIEBALL)
-- Spawned icon from ball thinker
addHook("MobjThinker", function(mobj)
	mobj.frame = FF_FULLBRIGHT|A
	if leveltime%(TICRATE/2) > (TICRATE/4) mobj.color = 30
	else mobj.color = 31 end
end, MT_TRYWHIP)


------ Bestieball object hook
addHook("MobjThinker", function(mobj)
--if mapheaderinfo[gamemap].lvlttl == "Rutile Preserve"
    
    --mobj.health = 1000
	mobj.scalespeed = FRACUNIT/25

	--if (mobj.flags & MF_NOCLIPTHING) mobj.flags = $ - MF_NOCLIPTHING end
	-- should remove those icons after a minute??
	--if (leveltime == TICRATE*70 and mobj.bestie_icon) mobj.bestie_icon = P_RemoveMobj(mobj.bestie_icon) end


    if mobj.beastie_Decay > 0 mobj.beastie_Decay = $-1 end

	--- when touching floor
    if (mobj.eflags & MFE_JUSTHITFLOOR) and mobj.beastie_Bounce > 0
        mobj.beastie_Bounce = $-1
		if mobj.beastie_Power >= 2 mobj.beastie_Power = $-1 end
		
        mobj.momz = FRACUNIT*4
    end -- sort of failsafe if it doesn't seem to hit the ground
	if mobj.momz == 0 and mobj.beastie_Bounce > 0 mobj.beastie_Bounce = $-1; mobj.momz = FRACUNIT*8 end

	-- stop moving (WIP)
	if (mobj.beastie_Bounce == 0 and P_IsObjectOnGround(mobj)) -- if on ground
	 or (mobj.beastie_Bounce == 0 and P_IsObjectInGoop(mobj)) -- or on water (goop)
		mobj.color = 5 -- return to normal color
		mobj.colorized = false
		mobj.tracer = nil
		mobj.beastie_Power = 0

		-- reset bestie vars
		if mobj.beastie_Respawntime > 0 mobj.beastie_Respawntime = $-1 end
	else -- code during bouncing mouvement
		mobj.rollangle = $ + ANG2*2
		mobj.colorized = false
		-- remove icon
		if mobj.bestie_icon mobj.bestie_icon = P_RemoveMobj(mobj.bestie_icon) end

		if leveltime%8 == 1 and mobj.beastie_Power == 1 P_SpawnGhostMobj(mobj) end -- power 1
		if leveltime%4 == 1 and mobj.beastie_Power >= 2 P_SpawnGhostMobj(mobj) end -- power 2
		if mobj.beastie_Power >= 2 mobj.colorized = true; mobj.rollangle = $ + ANG10 end
		--print(mobj.momz)
	end

	if mobj.beastie_Respawntime < TICRATE
		mobj.destscale = mapheaderinfo[gamemap].mobj_scale/500
	end
	-- return to spawn point
	if mobj.beastie_Respawntime == 0
		P_MoveOrigin(mobj, mobj.beastie_SpawnX, mobj.beastie_SpawnY, mobj.beastie_SpawnZ)
		if mobj.bestie_icon == nil 
		 mobj.bestie_icon = P_SpawnMobj(mobj.x, mobj.y, mobj.z+120*FRACUNIT, MT_TRYWHIP)
		 mobj.bestie_icon.destscale = mapheaderinfo[gamemap].mobj_scale*3
		end
		mobj.destscale = mapheaderinfo[gamemap].mobj_scale*7/4
		mobj.beastie_Power = 0
		mobj.rollangle = 0
		mobj.colorized = false
	end

--end

end, MT_BESTIEBALL)



------ 		COLLISION


local function Beastie_ballCollide(ball, mo)
	if ball.hitlag > 0 return true end
	
	
    --if not (mo.player) and (mo.valid) return true end
	
	--print(ball.beastie_Bounce)

	-- damge enemy
	if ball.tracer != nil and ball.tracer != mo and mo.player
		

		-- power 1
		if ball.beastie_Power == 1
			-- but if the player reflects the attack
			if mo.player.oldguard > 0 or K_PowerUpRemaining(mo.player, POWERUP_BARRIER)
				ball.beastie_Decay = TICRATE/2
				ball.beastie_Bounce = 5 --3 (default)
				ball.beastie_Power = 1
				ball.tracer = mo
				--ball.scale = mapheaderinfo[gamemap].mobj_scale*7/4
				-- debug hit hitbox
				--ball.scale = mapheaderinfo[gamemap].mobj_scale*2

				if (mo.player) ball.color = mo.player.skincolor end --gets the player color
			
				ball.momz = FRACUNIT
				if mo.player
					K_AddHitLag(mo, TICRATE/4, false)
					K_AddHitLag(ball, TICRATE/4, false)
					S_StartSound(mo, sfx_parry)
					P_InstaThrust(ball, InvAngle(-ball.angle), (ball.momx + ball.momy)*4/3)
					ball.angle = InvAngle(-$)
				end 
				return true
			end
		--- HIT conditions
		if mo.player.flashing == 0 and mo.player.invincibilitytimer == 0 and mo.player.growshrinktimer <= 0 and mo.player.hyudorotimer == 0
		 and mo.player.flamedash == 0
			ball.beastie_Bounce = 5--3 -- keep bouncing

			
			
			if gametype == GT_BATTLE P_DamageMobj(mo, ball.tracer, ball, 1, DMG_TUMBLE) -- will stun the attacker in battle
			 P_AddPlayerScore(ball.tracer.player, 1)
			 K_SpawnBattlePoints(ball.tracer.player, mo.player, 1)
			else P_DamageMobj(mo, ball, ball, 1, DMG_TUMBLE) end
			K_AddHitLag(mo, TICRATE/3, true)
			K_PlayHitEmSound(ball.tracer)
		end
		-- power 2
		elseif ball.beastie_Power >= 2
			-- but if the player reflects the attack
			if mo.player.oldguard > 0 or K_PowerUpRemaining(mo.player, POWERUP_BARRIER)
				ball.beastie_Decay = TICRATE/2
				ball.beastie_Bounce = 5 --3 (default)
				ball.beastie_Power = $+1
				ball.tracer = mo
				--ball.scale = mapheaderinfo[gamemap].mobj_scale*7/4
				-- debug hit hitbox
				--ball.scale = mapheaderinfo[gamemap].mobj_scale*2

				if (mo.player) ball.color = mo.player.skincolor end --gets the player color
			
				ball.momz = FRACUNIT
				if mo.player
					K_AddHitLag(mo, TICRATE/4, false)
					K_AddHitLag(ball, TICRATE/4, false)
					S_StartSound(mo, sfx_parry)
					P_InstaThrust(ball, InvAngle(-ball.angle), (ball.momx + ball.momy)*4/3)
					ball.angle = InvAngle(-$)
				end 
				return true
			end
		--- HIT conditions
		if mo.player.flashing == 0 and mo.player.invincibilitytimer == 0 and mo.player.growshrinktimer <= 0 and mo.player.hyudorotimer == 0
		 and mo.player.flamedash == 0
		 	S_StartSound(mo, sfx_dmga3)
			K_AddHitLag(mo, TICRATE/2, true)
			K_AddHitLag(ball, TICRATE/2, true)
			if gametype == GT_BATTLE P_DamageMobj(mo, ball.tracer, ball, 1, DMG_INSTAKILL) -- will stun the attacker in battle
			 P_AddPlayerScore(ball.tracer.player, 3)
			 K_SpawnBattlePoints(ball.tracer.player, mo.player, 3)
			else P_DamageMobj(mo, ball, ball, 1, DMG_INSTAKILL) end

			K_PlayHitEmSound(ball.tracer)
		end
		end
	end

	-- initial launch by player touch
	if ball.tracer == nil or ball.tracer == mo 
		if ball.beastie_Decay == 0 and mo.player
			ball.beastie_Decay = TICRATE/2
			ball.beastie_Bounce = 5 --3 (default)
			ball.beastie_Power = 1
			ball.tracer = mo
			--ball.scale = mapheaderinfo[gamemap].mobj_scale*7/4
			-- debug hit hitbox
			

			ball.beastie_Respawntime = TICRATE*10 -- set to 10/15/20?

			if (mo.player) ball.color = mo.player.skincolor end --gets the player color
			--print("collide")
			

			-- debug force: 3 real: 8
			ball.momz = FRACUNIT*4--FRACUNIT*8
			if mo.player
			 	P_Thrust(ball, mo.angle, mo.player.speed*4/3) -- x1.25
				if mo.player.flamedash > 2 				------ Flame shield effect
					P_Thrust(ball, mo.angle, mo.player.speed) -- add x1
					ball.beastie_Power = 2
					S_StartSound(mo, sfx_dmga1)
					K_AddHitLag(mo, TICRATE/3, false)
					K_AddHitLag(ball, TICRATE/3, true)
				end
				ball.angle = mo.angle
				ball.destscale = ball.tracer.scale*2
			end 
			
		end
		
	end
	--end
	return true
	
end


-- instawhip launch
local function Beastie_whipCollide(ball, mo)
	if (ball.z + ball.height >= mo.z) and (ball.z <= mo.z + mo.height) 
	if mo.type == MT_INSTAWHIP
		if ball.hitlag > 0 return true end
		--print("boom")
		--print(mo.target.skin) -- this is the player
		--print(mo.tracer.skin)

		ball.beastie_Decay = TICRATE/2
		ball.beastie_Bounce = 5 --3 (default)
		ball.beastie_Power = $+2
		ball.tracer = mo.target
		--ball.scale = mapheaderinfo[gamemap].mobj_scale*7/4
		-- debug hit hitbox
		--ball.scale = mapheaderinfo[gamemap].mobj_scale*2

		ball.beastie_Respawntime = TICRATE*10 -- set to 10/15/20?

		if (mo.target.player) ball.color = mo.target.player.skincolor end --gets the player color
		--print("collide")
		

		-- debug force: 3 real: 4
		ball.momz = FRACUNIT*3--FRACUNIT*4
		if mo.target.player
		 	if gametype == GT_BATTLE P_Thrust(ball, mo.target.angle, mo.target.player.speed+(FRACUNIT*28)) -- fixed speed
			else P_Thrust(ball, mo.target.angle, mo.target.player.speed+(FRACUNIT*40)) end
			K_AddHitLag(ball, TICRATE/3, true)
			S_StartSound(mo, sfx_dmga1)
			ball.angle = mo.target.angle
			ball.destscale = ball.tracer.scale*2
		end
		return true
	end
	end
end

-- MF_SHOOTABLE OBJECTS
local function Beastie_shootCollide(ball, mo)
	if (ball.z + ball.height >= mo.z) and (ball.z <= mo.z + mo.height) 
	if mo.player return end
	-- do not affect those items:
	if mo.type == MT_INSTAWHIP return end
	if mo.type == MT_EGGMANITEM or mo.type == MT_EGGMANITEM_SHIELD or mo.type == MT_BANANA_SHIELD or mo.type == MT_ORBINAUT_SHIELD or mo.type == MT_JAWZ_SHIELD
	 or mo.type == MT_SSMINE_SHIELD or mo.type == MT_SINK or mo.type == MT_SINK_SHIELD
	return end

	if (mo.flags & MF_SHOOTABLE) or (mo.type == MT_GARDENTOP) or (mo.type == MT_DROPTARGET)-- and ball.tracer != nil
		
		if ball.beastie_Decay == 0 and mo.target and mo.target.player
			ball.beastie_Decay = TICRATE/2
			ball.beastie_Bounce = 3
			ball.beastie_Power = 1
			ball.tracer = mo.target
			--ball.scale = mapheaderinfo[gamemap].mobj_scale*7/4
			-- debug hit hitbox
			ball.destscale = mapheaderinfo[gamemap].mobj_scale*2

			ball.beastie_Respawntime = TICRATE*10 -- set to 10/15/20?

			if (mo.target) and (mo.target.player)
			 ball.color = mo.target.player.skincolor --gets the player color
			end 
			--print("collide")
			

			-- debug force: 3 real: 8
			
			if mo.type == MT_GARDENTOP
				ball.momx = FRACUNIT*40
				ball.momy = FRACUNIT*40
				ball.angle = mo.angle

				ball.beastie_Bounce = 9
				ball.beastie_Power = 9
				ball.momz = FRACUNIT*2
			elseif mo.type == MT_DROPTARGET
				ball.momx = $*2+mo.momx*4
				ball.momy = $*2+mo.momy*4
				ball.angle = mo.angle
				ball.momz = FRACUNIT*3

				ball.beastie_Bounce = 5
			else
				ball.momx = $*2+mo.momx*2/3
				ball.momy = $*2+mo.momy*2/3
				ball.angle = mo.angle
				ball.momz = FRACUNIT*4
			end
			
		end

		K_AddHitLag(ball, TICRATE/3, true)
		K_AddHitLag(mo, TICRATE/2, true)
		S_StartSound(mo, sfx_dmga1)
		if mo.type == MT_SPECIAL_UFO -- damage for attacking the UFO catcher
			
			--mo.health = $ - 50
			P_DamageMobj(mo, ball.tracer, ball, 1, DMG_WIPEOUT) -- does player boost dmg (15)
			--print(mo.health)
			ball.beastie_Power = $-1 -- reduce the power, one power is one hit
			if ball.beastie_Power == 0
				P_KillMobj(ball, ball, ball, DMG_INSTAKILL) -- remove the ball, there's no need to reuse the same one
			end
			--ball.fuse = 1 
		-- default damage
		else P_KillMobj(mo, ball, ball, DMG_INSTAKILL) end
	end
	end

end


addHook("TouchSpecial", Beastie_ballCollide, MT_BESTIEBALL)
addHook("MobjCollide", Beastie_whipCollide, MT_BESTIEBALL)
addHook("MobjCollide", Beastie_shootCollide, MT_BESTIEBALL)