--- OBJECT CONFIG ---
freeslot("MT_HEATFIRE", "SPR_HFLMA0", "S_DHEATFIRE") -- Flames drops
freeslot("MT_HEATBUBL", "SPR_HBBLA0", "S_DHEATBUBL") -- Bubbles drops

-- instawhip icon
states[S_DHEATFIRE] = {
	sprite = SPR_HFLMA0,
	frame = A,
	tics = -1,
	action = nil,
	var1 = 0,
	var2 = 0,
	nextstate = S_NULL
}
-- instawhip icon
states[S_DHEATBUBL] = {
	sprite = SPR_HBBLA0,
	frame = A,
	tics = -1,
	action = nil,
	var1 = 0,
	var2 = 0,
	nextstate = S_NULL
}


-- ball
mobjinfo[MT_HEATFIRE] = {
	doomednum = -1,
	spawnstate = S_DHEATFIRE,
	deathstate = S_NULL,
    spawnhealth = 1,
	speed = 1,
	radius = 16*FRACUNIT,
	height = 16*FRACUNIT,
	flags = MF_SPECIAL|MF_NOGRAVITY
}
-- ball
mobjinfo[MT_HEATBUBL] = {
	doomednum = -1,
	spawnstate = S_DHEATBUBL,
	deathstate = S_NULL,
    spawnhealth = 1,
	speed = 1,
	radius = 16*FRACUNIT,
	height = 16*FRACUNIT,
	flags = MF_SPECIAL|MF_NOGRAVITY
}

addHook("PlayerThink", function(player)
if HeatOG_Active == false return end;
if player.exiting > 0 return end;

    -- conditions that spawn flames  ---- NOTE: check with ground texture instead of offroad
    if player.sneakertimer > TICRATE/4 or player.eggmanexplode > 0 or player.flamedash > 0
    if player.speed > mapheaderinfo[gamemap].mobj_scale*3
        if leveltime%8 == 1
            player.Dheat_FBDrop = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z+FRACUNIT*5, MT_HEATFIRE); 
            player.Dheat_FBDrop.target = player.mo;
            player.Dheat_FBDrop.momx = -player.mo.momx/8
            player.Dheat_FBDrop.momy = -player.mo.momy/8
            -- player.Dheat_FBDrop.fuse = TICRATE*2;
            -- player.Dheat_FBDrop.momz = FRACUNIT;
        end
    end
    end

    -- conditions that spawn Bubbles
    if player.curshield == 2 or player.DHeat_BlueTimer > 2 or player.wavedash > 0
    if player.speed > mapheaderinfo[gamemap].mobj_scale*4
        if leveltime%18 == 1
            player.Dheat_FBDrop = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z+FRACUNIT*5, MT_HEATBUBL); 
            player.Dheat_FBDrop.target = player.mo;
            player.Dheat_FBDrop.momx = -player.mo.momx/8
            player.Dheat_FBDrop.momy = -player.mo.momy/8
            -- player.Dheat_FBDrop.fuse = TICRATE*2;
            -- player.Dheat_FBDrop.momz = FRACUNIT;
        end
    end
    end

end)

local heatobjs = {MT_HEATFIRE, MT_HEATBUBL}
for _,i in pairs(heatobjs) do
    

    addHook("MobjSpawn", function(mobj)
        mobj.fuse = TICRATE*2;
        mobj.scale = $*2;
        if mobj.type == MT_HEATFIRE mobj.frame = FF_TRANS40|FF_FULLBRIGHT
        else mobj.frame = FF_FULLBRIGHT end
        --mobj.momz = FRACUNIT;
    end, i)

    addHook("MobjThinker", function(mobj)
        if HeatOG_Active == false return end;
        --mobj.fuse = TICRATE*2;
        mobj.momz = FRACUNIT/8;

    end, i)

    addHook("TouchSpecial", function(mobj, pl)
        --if HeatOG_Active == false return end;
        if mobj.target == pl return true end;

        if mobj.type == MT_HEATFIRE pl.player.DHeat_DMGtemp = $ + TICRATE/2
        else pl.player.DHeat_DMGtemp = $ - TICRATE/2 end
        P_RemoveMobj(mobj)

    return true end, i)
end